/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Send Tab URLs.
 *
 * The Initial Developer of the Original Code is 
 * Alex Eng <ateng@users.sourceforge.net>.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

// Dependencies:
//  - utils.js


const CLIPBOARD_URLCOUNT_DISABLED = 0;
const CLIPBOARD_URLCOUNT_TOP = 1;
const CLIPBOARD_URLCOUNT_BOTTOM = 2;

var gUtils;
var gAlwaysAskFmt, gWebMail, gConfCopy, gInclUrlCount, gUrlCountPos;
var gGoogAppsDomain;


function $(aID)
{
  return document.getElementById(aID);
}


function initDlg()
{
  gUtils = new aeSendTabsUtils();
  gAlwaysAskFmt = $("always-ask-formatting");
  gWebMail = $("webmail-radiogroup");
  gConfCopy = $("confirm-copy");
  gInclUrlCount = $("include-url-count");
  gUrlCountPos = $("url-count-position");
  gGoogAppsDomain = $("google-apps-domain");

  gAlwaysAskFmt.checked = gUtils.getPref("sendtabs.message.format.always_ask");

  var openInNewWnd = gUtils.getPref("sendtabs.webmail.open_in_new_window");
  gWebMail.selectedIndex = openInNewWnd ? 1 : 0;

  gConfCopy.checked = gUtils.getPref("sendtabs.mailclient.clipboard.confirm_copy");

  var clipbdUrlCountPos = gUtils.getPref("sendtabs.mailclient.clipboard.url_count");
  if (clipbdUrlCountPos != CLIPBOARD_URLCOUNT_DISABLED) {
    gInclUrlCount.checked = true;
    gUrlCountPos.selectedIndex = clipbdUrlCountPos - 1;
  }

  toggleClipboardURLCountPositonState(gInclUrlCount);

  gGoogAppsDomain.value = gUtils.getPref("sendtabs.mailclient.googleapps.domain", "");
}


function showFormatSettingsDlg()
{
  window.open("chrome://sendtabs/content/formatOpts.xul", "dlg_fmtsettings", "chrome,dialog,modal,centerscreen");
}


function toggleClipboardURLCountPositonState(aCheckboxElt)
{
  var isDisabled = !aCheckboxElt.checked;

  $("url-count-position-label-pre").disabled = isDisabled;
  $("url-count-position-label-post").disabled = isDisabled;
  $("url-count-position").disabled = isDisabled;
}


function doOK()
{
  var openInNewWnd = gWebMail.selectedIndex == 1;
  var clipbdUrlCountPos = 0;
  if (gInclUrlCount.checked) {
    clipbdUrlCountPos = gUrlCountPos.selectedIndex + 1;
  }

  gUtils.setPref("sendtabs.message.format.always_ask", gAlwaysAskFmt.checked);
  gUtils.setPref("sendtabs.webmail.open_in_new_window", openInNewWnd);
  gUtils.setPref("sendtabs.mailclient.clipboard.confirm_copy", gConfCopy.checked);
  gUtils.setPref("sendtabs.mailclient.clipboard.url_count", clipbdUrlCountPos);
  gUtils.setPref("sendtabs.mailclient.googleapps.domain", gGoogAppsDomain.value);

  return true;
}


function doCancel()
{
  return true;
}
